"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var util_1 = require("../util");
/**
 * @stable [26.02.2019]
 * @param {TEntity} changes
 * @param {TEntity} entity
 * @param {TEntity} originalEntity
 * @returns {IApiEntity<TEntity extends IEntity>}
 */
exports.apiEntityFactory = function (changes, entity, originalEntity) {
    var entityId = entity && entity.id;
    var base = util_1.notNilValuesFilter({
        changes: util_1.shallowClone(changes),
        merger: __assign({}, entity, changes),
    });
    return util_1.notNilValuesFilter(__assign({}, R.isNil(entityId)
        ? __assign({ newEntity: true }, base) : __assign({ entityId: entityId, newEntity: false, entity: util_1.shallowClone(entity), originalEntity: util_1.shallowClone(originalEntity) }, base)));
};
//# sourceMappingURL=api.support.js.map