import { IMessagesSettings } from '../../settings';
import { IReactButtonProps, IGenericButtonEntity } from '../../definition';
/**
 * @stable - 19.04.2018
 * @param {UniversalButtonEntityT} entity
 * @returns {boolean | undefined}
 */
export declare const isButtonDisabled: (entity: IReactButtonProps) => boolean;
/**
 * @stable - 19.04.2018
 * @param {UniversalButtonEntityT} entity
 * @param {IMessagesSettings} messages
 * @returns {string}
 */
export declare const getButtonText: (entity: IReactButtonProps, messages: IMessagesSettings) => string;
/**
 * @stable - 19.04.2018
 * @param {UniversalButtonEntityT} entity
 * @param {string} progressIcon
 * @param {string} errorIcon
 * @returns {string}
 */
export declare const getButtonIcon: (entity: IReactButtonProps, progressIcon: string, errorIcon: string) => string;
/**
 * @stable [23.02.2019]
 * @param {IGenericButtonEntity} props
 * @returns {boolean}
 */
export declare const hasIconButton: (props: IGenericButtonEntity) => boolean;
