import { IDomAccessor } from './dom-accessor.interface';
import { IXYEntity } from '../../entities-definitions.interface';
import { IJQueryElement } from '../../definitions.interface';
export declare class DomAccessor implements IDomAccessor {
    /**
     * @stable [16.02.2019]
     * @param {string | Element} selector
     * @param {Element} target
     * @returns {boolean}
     */
    hasElements(selector: string | Element, target: Element): boolean;
    /**
     * @stable [16.02.2019]
     * @param {string} selector
     * @param {Element} target
     * @returns {boolean}
     */
    hasParent(selector: string, target: Element): boolean;
    /**
     * @stable [13.01.2019]
     * @returns {Element}
     */
    getRootElement(): Element;
    /**
     * @stable [13.01.2019]
     * @returns {Element}
     */
    getDocumentBodyElement(): Element;
    /**
     * @stable [13.01.2019]
     * @param {Element} element
     * @param {string} clsNames
     */
    addClassNameToElement(element: Element, ...clsNames: string[]): void;
    /**
     * @stable [13.01.2019]
     * @param {Element} element
     * @param {string} clsNames
     */
    removeClassNameFromElement(element: Element, ...clsNames: string[]): void;
    /**
     * @stable [18.12.2018]
     * @param {Element} el
     * @param {number} left
     */
    setScrollLeft(el: Element, left: number): void;
    /**
     * @stable [18.12.2018]
     * @param {Element} el
     * @returns {number}
     */
    getScrollLeft(el: Element): number;
    /**
     * @stable [18.12.2018]
     * @param {Element} el
     * @returns {number}
     */
    getScrollTop(el: Element): number;
    /**
     * @stable [13.12.2018]
     * @param {Element} source
     * @returns {number}
     */
    getHeight(source: Element): number;
    /**
     * @stable [13.12.2018]
     * @param {Element} source
     * @returns {IJQueryElement}
     */
    toJqEl(source: Element): IJQueryElement;
    /**
     * @stable [01.12.2018]
     * @param {Element} el
     * @returns {IXYEntity}
     */
    getScrollInfo(el: Element): IXYEntity;
    /**
     * @stable [01.12.2018]
     * @param {Element} source
     * @returns {number}
     */
    getContentHeight(source: Element): number;
    /**
     * @stable [01.12.2018]
     * @param {Element} parent
     * @returns {Element}
     */
    findUniversalSelectedElement(parent: Element): Element;
    /**
     * @stable [01.12.2018]
     * @param {IXYEntity | Element} payload
     * @param {Element} parent
     */
    scrollTo(payload: IXYEntity | Element, parent?: Element): void;
    /**
     * @stable [01.12.2018]
     * @param {Element} el
     * @param {number} top
     */
    setScrollTop(el: Element, top: number): void;
}
