"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var native_base_1 = require("native-base");
var util_1 = require("../../../util");
var universal_container_1 = require("../../base/universal.container");
var rn_drawer_component_1 = require("../../drawer/rn-drawer.component");
var rn_button_component_1 = require("../../button/rn-button.component");
var RnDefaultLayoutContainer = /** @class */ (function (_super) {
    __extends(RnDefaultLayoutContainer, _super);
    /**
     * @stable [27.04.2018]
     * @param {IRnDefaultLayoutContainerProps} props
     */
    function RnDefaultLayoutContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.openDrawer = _this.openDrawer.bind(_this);
        return _this;
    }
    /**
     * @stable [27.04.2018]
     * @returns {JSX.Element}
     */
    RnDefaultLayoutContainer.prototype.render = function () {
        var _this = this;
        var props = this.props;
        var header = util_1.orNull(props.useHeader, function () { return (React.createElement(native_base_1.Header, { style: props.headerStyle },
            React.createElement(native_base_1.Left, null,
                util_1.orNull(props.headerBackActionEnabled, function () { return (React.createElement(rn_button_component_1.RnButton, { transparent: true, icon: 'arrow-back', style: props.headerActionStyle, iconStyle: props.headerActionIconStyle, onPress: _this.navigateToBack })); }),
                util_1.orNull(props.headerMenuActionEnabled && !props.headerBackActionEnabled, function () { return (React.createElement(rn_button_component_1.RnButton, { transparent: true, icon: 'menu', style: props.headerActionStyle, iconStyle: props.headerActionIconStyle, onPress: _this.openDrawer })); })),
            React.createElement(native_base_1.Body, null, util_1.orNull(props.title, function () { return (React.createElement(native_base_1.Title, { style: props.headerTitleStyle }, _this.t(props.title))); })),
            util_1.orNull(props.headerContent, function () { return (React.createElement(native_base_1.Right, null, props.headerContent)); }))); });
        var body = (React.createElement(native_base_1.Container, null,
            header,
            React.createElement(native_base_1.Content, { style: props.contentStyle }, props.children)));
        if (props.useDrawer) {
            return (React.createElement(rn_drawer_component_1.RnDrawer, { ref: function (ref) { return (_this.drawer = ref); }, content: React.createElement(native_base_1.Content, { style: props.drawerContentStyle }, props.drawerContent) }, body));
        }
        return body;
    };
    /**
     * @stable [27.04.2018]
     */
    RnDefaultLayoutContainer.prototype.openDrawer = function () {
        this.drawer.open();
    };
    /**
     * @stable [27.04.2018]
     */
    RnDefaultLayoutContainer.prototype.closeDrawer = function () {
        this.drawer.clone();
    };
    RnDefaultLayoutContainer.defaultProps = {
        useDrawer: true,
        useHeader: true,
        headerMenuActionEnabled: true,
    };
    return RnDefaultLayoutContainer;
}(universal_container_1.UniversalContainer));
exports.RnDefaultLayoutContainer = RnDefaultLayoutContainer;
//# sourceMappingURL=rn-default-layout.container.js.map