"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var menu_1 = require("@material/menu");
var util_1 = require("../../../util");
var material_plugin_1 = require("./material.plugin");
var MenuMaterialPlugin = /** @class */ (function (_super) {
    __extends(MenuMaterialPlugin, _super);
    /**
     * @stable [04.10.2018]
     * @param {TMenu} menu
     */
    function MenuMaterialPlugin(menu) {
        var _this = _super.call(this, menu, menu_1.MDCMenu) || this;
        // Complete the component behavior
        menu.isOpen = _this.isMenuOpen.bind(_this);
        menu.show = util_1.sequence(menu.show, _this.show, _this);
        menu.hide = util_1.sequence(menu.hide, _this.hide, _this);
        return _this;
    }
    /**
     * @stable [04.10.2018]
     */
    MenuMaterialPlugin.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        if (!util_1.isParentDocumentBody(this.component.getSelf())) {
            this.mdc.hoistMenuToBody(); // Prevent an outer container scroll appearing
        }
    };
    /**
     * @stable [19.11.2018]
     */
    MenuMaterialPlugin.prototype.componentWillUnmount = function () {
        _super.prototype.componentWillUnmount.call(this);
        util_1.removeSelf(this.component.getSelf()); // Because of hoistMenuToBody
    };
    /**
     * @stable [04.10.2018]
     */
    MenuMaterialPlugin.prototype.isMenuOpen = function () {
        return this.mdc && this.mdc.open;
    };
    /**
     * @stable [04.10.2018]
     */
    MenuMaterialPlugin.prototype.show = function () {
        this.mdc.open = true;
    };
    /**
     * @stable [04.10.2018]
     */
    MenuMaterialPlugin.prototype.hide = function () {
        this.mdc.open = false;
    };
    return MenuMaterialPlugin;
}(material_plugin_1.MaterialPlugin));
exports.MenuMaterialPlugin = MenuMaterialPlugin;
//# sourceMappingURL=menu-material.plugin.js.map