import { IEventManager } from './event-manager.interface';
import { AnyT } from '../definitions.interface';
export declare class EventManager implements IEventManager {
    /**
     * @stable [23.02.2019]
     * @param {EventTarget} el
     * @param {string} type
     * @param {(...args) => AnyT} callback
     * @param {boolean} capturing
     * @returns {() => void}
     */
    subscribe(el: EventTarget, type: string, callback: (...args: any[]) => void, capturing?: boolean): () => void;
    /**
     * @stable [23.02.2019]
     * @param {EventTarget} el
     * @param {string} type
     * @param {(...args) => void} callback
     * @param {boolean} capturing
     */
    add(el: EventTarget, type: string, callback: (...args: any[]) => void, capturing?: boolean): void;
    /**
     * @stable [23.02.2019]
     * @param {EventTarget} el
     * @param {string} type
     * @param {(...args) => void} callback
     * @param {boolean} capturing
     */
    remove(el: EventTarget, type: string, callback: (...args: any[]) => void, capturing?: boolean): void;
    /**
     * @stable [23.02.2019]
     * @param {EventTarget} el
     * @param {string} type
     * @param {(...args) => void} callback
     * @param {AnyT} model
     */
    fabricate(el: EventTarget, type: string, callback: (...args: any[]) => void, model?: AnyT): void;
}
