"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var Promise = require("bluebird");
var inversify_1 = require("inversify");
var util_1 = require("../../util");
var di_1 = require("../../di");
var GeoCoder = /** @class */ (function () {
    function GeoCoder() {
    }
    /**
     * @stable [30.07.2018]
     * @param {google.maps.GeocoderRequest} request
     * @returns {Bluebird<google.maps.GeocoderResult[]>}
     */
    GeoCoder.prototype.geocode = function (request) {
        var _this = this;
        return this.getScriptPromise().then(function () { return new Promise(function (resolve) {
            _this.geocoder.geocode(request, function (geocoderResults) { return resolve(geocoderResults); });
        }); });
    };
    /**
     * @stable [30.07.2018]
     * @returns {Bluebird<void>}
     */
    GeoCoder.prototype.getScriptPromise = function () {
        var _this = this;
        return util_1.getGoogleMapsScript(this.settings.googleMaps.libraries).then(function () { return _this.initGoogleMapsObjects(); });
    };
    /**
     * @stable [30.07.2018]
     */
    GeoCoder.prototype.initGoogleMapsObjects = function () {
        this.geocoder = new google.maps.Geocoder();
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], GeoCoder.prototype, "settings", void 0);
    GeoCoder = __decorate([
        inversify_1.injectable()
    ], GeoCoder);
    return GeoCoder;
}());
exports.GeoCoder = GeoCoder;
//# sourceMappingURL=geocoder.service.js.map