import { ITransportRequestEntity } from '../transport.interface';
import { ITransportFactory, ITransportFactoryResponseEntity } from './transport-factory.interface';
export declare class TransportFactory implements ITransportFactory {
    private readonly cancelUuid;
    private readonly operationsIdsMap;
    private readonly settings;
    private readonly requestProvider;
    private readonly requestPayloadFactory;
    private readonly responseFactory;
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {Promise<ITransportFactoryResponseEntity>}
     */
    request(req: ITransportRequestEntity): Promise<ITransportFactoryResponseEntity>;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     */
    cancelRequest(req: ITransportRequestEntity): void;
    /**
     * @stable [01.02.2019]
     * @param {string} operationId
     */
    private clearOperation;
    /**
     * @stable [02.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportResponseFactory}
     */
    private getResponseFactory;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {string}
     */
    private toOperationId;
}
