"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var di_1 = require("../di");
var transport_service_1 = require("./transport.service");
var transport_error_interceptor_1 = require("./transport-error.interceptor");
var transport_request_provider_service_1 = require("./request/provider/transport-request-provider.service");
var transport_token_accessor_1 = require("./transport-token.accessor");
var fetch_json_transport_factory_1 = require("./fetch-json-transport.factory");
require("./transport.effects");
require("./factory/transport-factory.module");
require("./request/transport-request.module");
require("./response/transport-response.module");
di_1.appContainer.bind(di_1.DI_TYPES.TransportTokenAccessor).to(transport_token_accessor_1.TransportTokenAccessor).inSingletonScope();
di_1.appContainer.bind(di_1.DI_TYPES.TransportRequestProvider).to(transport_request_provider_service_1.TransportRequestProvider).inSingletonScope();
di_1.appContainer.bind(di_1.DI_TYPES.Transport).to(transport_service_1.Transport).inSingletonScope();
di_1.appContainer.bind(di_1.DI_TYPES.TransportErrorInterceptor).to(transport_error_interceptor_1.TransportErrorInterceptor).inSingletonScope();
di_1.bindInSingleton(fetch_json_transport_factory_1.FetchJsonTransportFactory);
//# sourceMappingURL=transport.module.js.map