"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var util_1 = require("../util");
/**
 * @stable [24.01.2019]
 * @param {TEntity} entity
 * @returns {TEntity}
 */
exports.shallowClone = function (entity) {
    return util_1.ifNotNilThanValue(entity, function () { return (__assign({}, entity)); });
};
/**
 * @stable [14.06.2018]
 * @param {T} o
 * @returns {T}
 */
exports.clone = function (o) { return R.clone(o); };
exports.cloneReactNodes = function (component, mergedProps, mergePropsPredicate, childrenMap, renderPredicate) {
    return React.Children.map(component.props.children, function (child) {
        if (R.isNil(child)) {
            return null;
        }
        else if (util_1.isPrimitive(child)) {
            return child;
        }
        else {
            var reactChild = child;
            var ref = reactChild.ref || util_1.uuid();
            var canMergeProps = mergePropsPredicate(reactChild);
            var canRender = renderPredicate ? renderPredicate(reactChild) : true;
            if (!R.isNil(canRender) && !canRender) {
                return null;
            }
            var clonedChild = React.cloneElement(reactChild, __assign({}, (canMergeProps && __assign({ ref: ref }, util_1.calc(mergedProps, reactChild))), { children: exports.cloneReactNodes(reactChild, mergedProps, mergePropsPredicate, childrenMap, renderPredicate) }));
            if (childrenMap && canMergeProps) {
                childrenMap.set(clonedChild, ref);
            }
            return clonedChild;
        }
    });
};
//# sourceMappingURL=clone.js.map