import { IEntity } from '../definitions.interface';
import { IEditableEntity, IEntityFormEntity } from '../entities-definitions.interface';
import { IExtendedEntity } from '../definition';
import { ValidatorRuleEnum } from './validator';
/**
 * @stable [30.01.2019]
 * @param {Record<string, ValidatorRuleEnum[]>} payloads
 * @param {IEditableEntity<TEntity extends IEntity>} editableEntity
 * @param {boolean} canSaveEmptyChanges
 * @returns {boolean}
 */
export declare const canSubmitEditableEntity: <TEntity extends IEntity>(payloads: Record<string, ValidatorRuleEnum[]>, editableEntity: IEditableEntity<TEntity>, canSaveEmptyChanges?: boolean) => boolean;
/**
 * @stable [30.01.2019]
 * @param {IEntityFormEntity<TEntity extends IEntity>} entity
 * @param {Record<string, ValidatorRuleEnum[]>} editRules
 * @param {Record<string, ValidatorRuleEnum[]>} createRules
 * @returns {boolean}
 */
export declare const canSubmitEntityFormEntity: <TEntity extends IEntity>(entity: IEntityFormEntity<TEntity>, editRules: Record<string, ValidatorRuleEnum[]>, createRules?: Record<string, ValidatorRuleEnum[]>) => boolean;
/**
 * @stable [30.01.2019]
 * @param {IEditableEntity<TEntity extends IEntity>} editableEntity
 * @returns {boolean}
 */
export declare const isEditableEntityBusy: <TEntity extends IEntity>(editableEntity: IEditableEntity<TEntity>) => boolean;
/**
 * @stable [30.01.2019]
 * @param {IEntityFormEntity<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isEntityFormEntityBusy: <TEntity extends IEntity>(entity: IEntityFormEntity<TEntity>) => boolean;
/**
 * @stable [30.01.2019]
 * @param {IExtendedEntity<TEntity extends IEntity>} entityWrapper
 * @returns {boolean}
 */
export declare const isNewEntity: <TEntity extends IEntity>(entityWrapper: IExtendedEntity<TEntity>) => boolean;
/**
 * @stable [30.01.2019]
 * @param {IExtendedEntity<TEntity extends IEntity>} entityWrapper
 * @returns {boolean}
 */
export declare const doesEntityExist: <TEntity extends IEntity>(entityWrapper: IExtendedEntity<TEntity>) => boolean;
