"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
/**
 * @stable [16.05.2018]
 * @param {IBaseEvent} event
 */
exports.cancelEvent = function (event) {
    if (R.isNil(event)) {
        return;
    }
    if (event.nativeEvent) {
        /**
         * Will prevent any parent handlers and also any other handlers from executing
         */
        event.nativeEvent.stopImmediatePropagation();
    }
    event.stopPropagation();
    event.preventDefault();
};
//# sourceMappingURL=event.js.map