"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var util_1 = require("../../../util");
var di_1 = require("../../../di");
var base_transport_request_payload_factory_service_1 = require("./base-transport-request-payload-factory.service");
var TransportRequestPayloadFactory = /** @class */ (function (_super) {
    __extends(TransportRequestPayloadFactory, _super);
    function TransportRequestPayloadFactory() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.id = 0;
        return _this;
    }
    /**
     * @stable [02.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportRequestPayloadDataEntity}
     */
    TransportRequestPayloadFactory.prototype.makeRequestPayloadData = function (req) {
        var _this = this;
        return util_1.notNilValuesFilter({
            id: this.id++,
            name: req.name,
            params: req.params && util_1.defValuesFilter(req.params),
            auth: util_1.orNull(req.noAuth !== true, function () { return _this.tokenAccessor.token; }),
        });
    };
    /**
     * @stable [02.02.2019]
     * @param {ITransportRequestEntity} requestEntity
     * @returns {string}
     */
    TransportRequestPayloadFactory.prototype.getBaseUrl = function (requestEntity) {
        var transportSettings = this.settings.transport;
        return requestEntity.url
            || util_1.notNilValuesArrayFilter(this.isBinaryData(requestEntity) ? transportSettings.binaryUrl : transportSettings.apiUrl, requestEntity.path).join(''); // URI's segment works incorrectly with a UUID (url.segment(req.path));
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.TransportTokenAccessor),
        __metadata("design:type", Object)
    ], TransportRequestPayloadFactory.prototype, "tokenAccessor", void 0);
    TransportRequestPayloadFactory = __decorate([
        inversify_1.injectable()
    ], TransportRequestPayloadFactory);
    return TransportRequestPayloadFactory;
}(base_transport_request_payload_factory_service_1.BaseTransportRequestPayloadFactory));
exports.TransportRequestPayloadFactory = TransportRequestPayloadFactory;
//# sourceMappingURL=transport-request-payload-factory.service.js.map